<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Specification\OrderItem;

use Dedi\SyliusQuotePlugin\Entity\OrderInterface;
use Dedi\SyliusQuotePlugin\Entity\OrderItemInterface;
use Dedi\SyliusQuotePlugin\Specification\Order\IsFromQuoteSpecification as OrderIsFromQuoteSpecification;

class IsFromQuoteSpecification
{
    private OrderIsFromQuoteSpecification $orderIsFromQuoteSpecification;

    public function __construct(OrderIsFromQuoteSpecification $orderIsFromQuoteSpecification)
    {
        $this->orderIsFromQuoteSpecification = $orderIsFromQuoteSpecification;
    }

    public function isSatisfiedBy(OrderItemInterface $orderItem): bool
    {
        /** @var ?OrderInterface $order */
        $order = $orderItem->getOrder();

        if (null === $order) {
            return false;
        }

        return $this->orderIsFromQuoteSpecification->isSatisfiedBy($order);
    }
}
